gm montage
NAME
| montage - create a composite image by combining several separate images
Contents
| Synopsis Description Examples Options X Resources Environment Configuration File Authors Copyright
Synopsis
| montage [ options ...] file [ [ options ...] file ...] output_file
Description
| montage creates a composite image by combining several separate images. The images are tiled on the composite image with the name of the image optionally appearing just below the individual tile. The composite image is constructed in the following manner. First, each image specified on the command line, except for the last, is scaled to fit the maximum tile size. The maximum tile size by default is 120x120. It can be modified with the -geometry command line argument or X resource. See Options for more information on command line arguments. See X(1) for more information on X resources. Note that the maximum tile size need not be a square. Next the composite image is initialized with the color specified by the -background command line argument or X resource. The width and height of the composite image is determined by the title specified, the maximum tile size, the number of tiles per row, the tile border width and height, the image border width, and the label height. The number of tiles per row specifies how many images are to appear in each row of the composite image. The default is to have 5 tiles in each row and 4 tiles in each column of the composite. A specific value is specified with -tile. The tile border width and height, and the image border width defaults to the value of the X resource -borderwidth. It can be changed with the -borderwidth or -geometry command line argument or X resource. The label height is determined by the font you specify with the -font command line argument or X resource. If you do not specify a font, a font is chosen that allows the name of the image to fit the maximum width of a tiled area. The label colors is determined by the -background and -fill command line argument or X resource. Note, that if the background and pen colors are the same, labels will not appear. Initially, the composite image title is placed at the top if one is specified (refer to -fill). Next, each image is set onto the composite image, surrounded by its border color, with its name centered just below it. The individual images are left-justified within the width of the tiled area. The order of the images is the same as they appear on the command line unless the images have a scene keyword. If a scene number is specified in each image, then the images are tiled onto the composite in the order of their scene number. Finally, the last argument on the command line is the name assigned to the composite image. By default, the image is written in the MIFF format and can be viewed or printed with display(1). Note, that if the number of tiles exceeds the default number of 20 (5 per row, 4 per column), more than one composite image is created. To ensure a single image is produced, use -tile to increase the number of tiles to meet or exceed the number of input images. Finally, to create one or more empty spaces in the sequence of tiles, use the "NULL:" image format. Note, a composite MIFF image displayed to an X server with display behaves differently than other images. You can think of the composite as a visual image directory. Choose a particular tile of the composite and press a button to display it. See display(1) and miff(5)
Back to Contents
Examples
| To create a montage of a cockatoo, a parrot, and a hummingbird and write it to a file called birds, use:
        gm montage cockatoo.miff parrot.miff hummingbird.miff birds.miff
To tile several bird images so that they are at most 256 pixels in width and 192 pixels in height, surrounded by a red border, and separated by 10 pixels of background color, use:
        gm montage -geometry 256x192+10+10 -bordercolor red birds.* montage.miff
To create an unlabeled parrot image, 640 by 480 pixels, and surrounded by a border of black, use:
        gm montage -geometry 640x480 -bordercolor black -label "" parrot.miff
    bird.miff
To create an image of an eagle with a textured background, use:
        gm montage -texture bumps.jpg eagle.jpg eagle.png
To join several GIF images together without any extraneous graphics (e.g. no label, no shadowing, no surrounding tile frame), use:
        gm montage +frame +shadow +label -tile 5x1 -geometry 50x50+0+0 *.png joined.png
Back to Contents
Options
| Any option you specify on the command line remains in effect for the group of images following it, until the group is terminated by the appearance of any option or -noop. For example, to make a montage of three images, the first with 32 colors, the second with an unlimited number of colors, and the third with only 16 colors, use:
        gm montage -colors 32 cockatoo.1 -noop cockatoo.2 -colors 16 cockatoo.3
    cockatoos.miff
For a more detailed description of each option, see Options, above. GraphicsMagick(1).
| -adjoin
| join images into a single multi-image file
| -affine <matrix>
| drawing transform matrix
| -authenticate <string>
| decrypt image with this password
| -background <color>
| the background color
| -blue-primary <x>,<y>
| blue chromaticity primary point
| -blur <radius>{x<sigma>}
| blur the image with a Gaussian operator
| -bordercolor <color>
| the border color
| -borderwidth <geometry>
| the border width
| -chop <width>x<height>{+-}<x>{+-}<y>{%}
| remove pixels from the interior of an image
| -colors <value>
| preferred number of colors in the image
| -colorspace <value>
| the type of colorspace
| -comment <string>
| annotate an image with a comment
| -compose <operator>
| the type of image composition
| -compress <type>
| the type of image compression
| -crop <width>x<height>{+-}<x>{+-}<y>{%}
| preferred size and location of the cropped image
| -debug <events>
| enable debug printout
| -define <key>{=<value>},...
| add coder/decoder specific options
| -density <width>x<height>
| horizontal and vertical resolution in pixels of the image
| -depth <value>
| depth of the image
| -display <host:display[.screen]>
| specifies the X server to contact
| -dispose <method>
| GIF disposal method
| -dither
| apply Floyd/Steinberg error diffusion to the image
| -draw <string>
| annotate an image with one or more graphic primitives
| -encoding <type>
| specify the text encoding
| -endian <type>
| specify endianness (MSB, LSB, or Native) of image
| -fill <color>
| color to use when filling a graphic primitive
| -filter <type>
| use this type of filter when resizing an image
| -font <name>
| use this font when annotating the image with text
| -frame <width>x<height>+<outer bevel width>+<inner bevel width>
| surround the image with an ornamental border
| -gamma <value>
| level of gamma correction
| -geometry <width>x<height>{+-}<x>{+-}<y>{%}{@}{!}{^}{<}{>}
| preferred size and location of the Image window.
| -gravity <type>
| direction primitive gravitates to when annotating the image.
| -green-primary <x>,<y>
| green chromaticity primary point
| -help
| print usage instructions
| -interlace <type>
| the type of interlacing scheme
| -label <name>
| assign a label to an image
| -limit <type> <value>
| Disk, File, Map, Memory, Pixels, or Threads resource limit
| -log <string>
| Specify format for debug log
| -matte
| store matte channel if the image has one
| -mattecolor <color>
| specify the color to be used with the -frame option
| -mode <value>
| mode of operation
| -monitor
| show progress indication
| -monochrome
| transform the image to black and white
| -noop
| NOOP (no option)
| -page <width>x<height>{+-}<x>{+-}<y>{%}{!}{<}{>}
| size and location of an image canvas
| -pen <color>
| (This option has been replaced by the -fill option)
| -pointsize <value>
| pointsize of the PostScript, X11, or TrueType font
| -quality <value>
| JPEG/MIFF/PNG/TIFF compression level
| -red-primary <x>,<y>
| red chromaticity primary point
| -render
| render vector operations
| -repage <width>x<height>+xoff+yoff[!]
| Adjust image page offsets
| -resize <width>x<height>{%}{@}{!}{<}{>}
| resize an image
| -rotate <degrees>{<}{>}
| rotate the image
| -sampling-factor <horizontal_factor>x<vertical_factor>
| chroma subsampling factors
| -scenes <value-value>
| range of image scene numbers to read
| -shadow <radius>{x<sigma>}
| shadow the montage
| -sharpen <radius>{x<sigma>}
| sharpen the image
| -size <width>x<height>{+offset}
| width and height of the image
| -strip
| remove all profiles and text attributes from the image
| -stroke <color>
| color to use when stroking a graphic primitive
| -strokewidth <value>
| set the stroke width
| -texture <filename>
| name of texture to tile onto the image background
| -thumbnail <width>x<height>{%}{@}{!}{<}{>}
| resize an image (quickly)
| -tile <geometry>
| layout of images [montage]
| -title <string>
| assign title to displayed image [animate, display, montage]
| -transform
| transform the image
| -transparent <color>
| make this color transparent within the image
| -treedepth <value>
| tree depth for the color reduction algorithm
| -trim
| trim an image
| -type <type>
| the image type
| -verbose
| print detailed information about the image
| -version
| print GraphicsMagick version string
| -white-point <x>,<y>
| chromaticity white point
For a more detailed description of each option, see Options, above. GraphicsMagick(1).
Back to Contents
X Resources
| Montage options can appear on the command line or in your X resource file. Options on the command line supersede values specified in your X resource file. See X(1) for more information on X resources. All montage options have a corresponding X resource. In addition, montage uses the following X resources:
| background (class Background)
| background color
Specifies the preferred color to use for the composite image background. The default is #ccc.
| borderColor (class BorderColor)
| border color
Specifies the preferred color to use for the composite image border. The default is #ccc.
| borderWidth (class BorderWidth)
| border width
Specifies the width in pixels of the composite image border. The default is 2.
| font (class Font)
| font to use
Specifies the name of the preferred font to use when displaying text within the composite image. The default is 9x15, fixed, or 5x8 determined by the composite image size.
| matteColor (class MatteColor)
| color of the frame
Specify the color of an image frame. A 3D effect is achieved by using highlight and shadow colors derived from this color. The default value is #697B8F.
| pen (class Pen)
| text color
Specifies the preferred color to use for text within the composite image. The default is black.
| title (class Title)
| composite image title
This resource specifies the title to be placed at the top of the composite image. The default is not to place a title at the top of the composite image.
Back to Contents
Environment
| COLUMNS
| Output screen width. Used when formatting text for the screen. Many Unix systems keep this shell variable up to date, but it may need to be explicitly exported in order for GraphicsMagick to see it.
| DISPLAY
| X11 display ID (host, display number, and screen in the form hostname:display.screen).
| HOME
| Location of user's home directory. GraphicsMagick searches for configuration files in $HOME/.magick if the directory exists. See MAGICK_CODER_MODULE_PATH, MAGICK_CONFIGURE_PATH, and MAGICK_FILTER_MODULE_PATH if more flexibility is needed.
| MAGICK_CODER_STABILITY
| The minimum coder stability level before it will be used. The available levels are PRIMARY, STABLE, and UNSTABLE. The default minimum level is UNSTABLE, which means that all available coders will be used. The purpose of this option is to reduce the security exposure (or apparent complexity) due to the huge number of formats supported. Coders at the PRIMARY level are commonly used formats with very well maintained implementations. Coders at the STABLE level are reasonably well maintained but represent less used formats. Coders at the UNSTABLE level either have weak implementations, the file format itself is weak, or the probability the coder will be needed is vanishingly small.
| MAGICK_CODER_MODULE_PATH
| Search path to use when searching for image format coder modules. This path allows the user to arbitrarily extend the image formats supported by GraphicsMagick by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_CONFIGURE_PATH
| Search path to use when searching for configuration (.mgk) files. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_DEBUG
| Debug options (see -debug for details)
| MAGICK_FILTER_MODULE_PATH
| Search path to use when searching for filter process modules (invoked via -process). This path allows the user to arbitrarily extend GraphicsMagick's image processing functionality by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_HOME
| Path to top of GraphicsMagick installation directory. Only observed by "uninstalled" builds of GraphicsMagick which do not have their location hard-coded or set by an installer.
| MAGICK_MMAP_READ
| If MAGICK_MMAP_READ is set to TRUE, GraphicsMagick will attempt to memory-map the input file for reading. This usually substantially improves read performance if the file has recently been read. However, testing shows that performance may be reduced for files accessed for the first time via a network since some operating systems failed to do read-ahead over network mounts for memory mapped files.
| MAGICK_MMAP_WRITE
| If MAGICK_MMAP_WRITE is set to TRUE, GraphicsMagick will attempt to memory-map the output file for writing. This is an experimental feature (which is currently broken). Write performance is usually somewhat worse when using this approach rather than the default one.
| MAGICK_IO_FSYNC
| If MAGICK_IO_FSYNC is set to TRUE, then GraphicsMagick will request that the output file is fully flushed and synchronized to disk when it is closed. This incurs a performance penalty, but has the benefit that if the power fails or the system crashes, the file should be valid on disk. If image files are referenced from a database, then this option helps assure that the files referenced by the database are valid.
| MAGICK_IOBUF_SIZE
| The amount of I/O buffering (in bytes) to use when reading and writing encoded files. The default is 16384, which is observed to work well for many cases. The best value for a local filesystem is usually the the native filesystem block size (e.g. 4096, 8192, or even 131,072 for ZFS) in order to minimize the number of physical disk I/O operations. I/O performance to files accessed over a network may benefit significantly by tuning this option. Larger values are not necessarily better (they may be slower!), and there is rarely any benefit from using values larger than 32768. Use convert's -verbose option in order to evaluate read and write rates in pixels per second while keeping in mind that the operating system will try to cache files in RAM.
| MAGICK_LIMIT_DISK
| Maximum amount of disk space allowed for use by the pixel cache.
| MAGICK_LIMIT_FILES
| Maximum number of open files.
| MAGICK_LIMIT_MAP
| Maximum size of a memory map.
| MAGICK_LIMIT_MEMORY
| Maximum amount of memory to allocate from the heap.
| MAGICK_TMPDIR
| Path to directory where GraphicsMagick should write temporary files. The default is to use the system default, or the location set by TMPDIR.
| TMPDIR
| For POSIX-compatible systems (Unix-compatible), the path to the directory where all applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.
| TMP or TEMP
| For Microsoft Windows, the path to the directory where applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.
| OMP_NUM_THREADS
| As per the OpenMP standard, this specifies the number of threads to use in parallel regions. Some compilers default the number of threads to use to the number of processor cores available while others default to just one thread. See the OpenMP specification for other standard adjustments and your compiler's manual for vendor-specific settings.
Back to Contents
Configuration Files
| GraphicsMagick uses a number of XML format configuration files:
| colors.mgk
| colors configuration file
      <?xml version="1.0"?>
      <colormap>
        <color name="AliceBlue" red="240" green="248" blue="255"
               compliance="SVG, X11, XPM" />
      </colormap>
| delegates.mgk
| delegates configuration file
| log.mgk
| logging configuration file
      <?xml version="1.0"?>
      <magicklog>
        <log events="None" />
        <log output="stdout" />
        <log filename="Magick-%d.log" />
        <log generations="3" />
        <log limit="2000" />
        <log format="%t %r %u %p %m/%f/%l/%d:\n  %e"  />
      </magicklog>
| modules.mgk
| loadable modules configuration file
      <?xml version="1.0"?>
      <modulemap>
        <module magick="8BIM" name="META" />
      </modulemap>
| type.mgk
| master type (fonts) configuration file
      <?xml version="1.0"?>
      <typemap>
        <include file="type-windows.mgk" />
        <type
          name="AvantGarde-Book"
          fullname="AvantGarde Book"
          family="AvantGarde"
          foundry="URW"
          weight="400"
          style="normal"
          stretch="normal"
          format="type1"
          metrics="/usr/local/share/ghostscript/fonts/a010013l.afm"
          glyphs="/usr/local/share/ghostscript/fonts/a010013l.pfb"
        />
      </typemap>
Back to Contents
Acknowledgements
| The MIT X Consortium for making network transparent graphics a reality. Michael Halle, Spatial Imaging Group at MIT, for the initial implementation of Alan Paeth's image rotation algorithm. David Pensak, E. I. du Pont de Nemours and Company, for providing a computing environment that made this program possible. Peder Langlo, Hewlett Packard, Norway, made hundreds of suggestions and bug reports. Without Peder, this software would not be nearly as useful as it is today. Rod Bogart and John W. Peterson, University of Utah. Image compositing is loosely based on rlecomp of the Utah Raster Toolkit. Paul Heckbert, Carnegie Mellon University. Image resizing is based on his Zoom program. Paul Raveling, USC Information Sciences Institute. The spatial subdivision color reduction algorithm is based on his Img software.
Back to Contents
Authors
| John Cristy, Bob Friesenhahn, Glenn Randers-Pehrson, William Radcliff, Leonard Rosenthol.
Back to Contents
Copyright
| Copyright (C) 2002 - 2010 GraphicsMagick Group, an organization dedicated to making software imaging solutions freely available. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files ("GraphicsMagick"), to deal in GraphicsMagick without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of GraphicsMagick, and to permit persons to whom GraphicsMagick is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of GraphicsMagick. The software is provided "as is", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness for a particular purpose and noninfringement. In no event shall GraphicsMagick Group be liable for any claim, damages or other liability, whether in an action of contract, tort or otherwise, arising from, out of or in connection with GraphicsMagick or the use or other dealings in GraphicsMagick. Except as contained in this notice, the name of the GraphicsMagick Group shall not be used in advertising or otherwise to promote the sale, use or other dealings in GraphicsMagick without prior written authorization from the GraphicsMagick Group. Additional copyrights and licenses apply to this software. You should have received a copy of Copyright.txt with this package, which describes additional copyrights and licenses which apply to this software; otherwise see http://www.graphicsmagick.org/Copyright.html.
Back to Contents [Home] [Utilities Index] Copyright © GraphicsMagick Group 2002 - 2011